function Xmas(N)

% This routine draws a Christmas tree.
%
% The transformations for the fern are each in the form
% T(x,y = (a*x+b*y+e, c*x+d*y+f). Each transformation is 
% executed iteratively with a certain probability.
%
% INPUT
%	N -> The number of iterations.

% Close all existing figure windows. Delete this line
% if you do not want this action.
close all

% Initialize figure window and axes
fig1=figure;
ax1=axes;

% Initialize some space to hold the sequence of points
% X1, X2, ..., XN
X=zeros(N,2);

% The initial value X1 = [0.5,0.5].
X(1,:)=[0.5,0.5];   % X(1,:) means "first row, every column."

% The main loop where the iterations are performed.
for k=1:N-1
	r=rand;
	if r<.2
		X(k+1,:)=T(X(k,:),0.8,0,0,0.8,0,0.15);
	elseif r<.4
		X(k+1,:)=T(X(k,:),-0.04,-0.4, 0.16,-0.1,0,0.1);
	elseif r<.6
		X(k+1,:)=T(X(k,:),-0.04, 0.4,-0.16,-0.1,0,0.15);
	elseif r<.8
		X(k+1,:)=T(X(k,:),.4,0,0,.8,0,0.3);
    else
		X(k+1,:)=T(X(k,:),0.3,-0,-0.1,0.6,0.01,-0.05);
	end
end

whitebg('white')
plot(X(:,1),X(:,2),'.','Color',[0,.3,.1],'markersize',1)

axis off

function U=T(X,a,b,c,d,e,f)
U=zeros(1,2);
U(1)=a*X(1)+b*X(2)+e;
U(2)=c*X(1)+d*X(2)+f;
